<?php
require_once 'functions.php';
require_once 'settings.php';
mb_language('Japanese');
mb_internal_encoding('utf-8');

// 設定ファイルの内容を utf-8 に変換.
$subject1 = mb_convert_encoding($subject1, 'utf-8', 'auto');
$subject2 = mb_convert_encoding($subject2, 'utf-8', 'auto');
$bodyHead1 = mb_convert_encoding($bodyHead1, 'utf-8', 'auto');
$bodyHead2 = mb_convert_encoding($bodyHead2, 'utf-8', 'auto');

// 復号化・入力チェック.
$params = ArgumentsCleaner::cleanup($_POST);
$params = convertEncodeArray($params, 'utf-8', 'auto');
$params['from'] = rot13decrypt($params['from']);
$params['from_name'] = rot13decrypt($params['from_name']);
$params['to'] = rot13decrypt($params['to']);
$params['thanks_url'] = rot13decrypt($params['thanks_url']);
$params['error_url'] = rot13decrypt($params['error_url']);
$params['thanks_url'] = preg_replace('/\r\n|\r|\n/', '', $params['thanks_url']);
$params['error_url'] = preg_replace('/\r\n|\r|\n/', '', $params['error_url']);
$params['from'] = $params['from'] ? $params['from'] : $params['to'];
preg_match('/^([a-zA-Z0-9])+([a-zA-Z0-9\._-])*@([a-zA-Z0-9_-])+([a-zA-Z0-9\._-]+)+$/', $params['to']) or exit('Error: メールの送信先が不正です。');
preg_match('/^([a-zA-Z0-9])+([a-zA-Z0-9\._-])*@([a-zA-Z0-9_-])+([a-zA-Z0-9\._-]+)+$/', $params['from']) or exit('Error: 差出人情報が不正です。');
!preg_match('/\r\n|\r|\n/', $params['from_name']) or exit('Error: 差出人情報が不正です。');

$to = $params['to'];
$from['reply'] = $params['from'];
$from['notice'] = ($params['from_user'] && isset($params['values']['メールアドレス'])) ? $params['values']['メールアドレス'] : $params['from'];
$fromName['reply'] = $params['from_name'];
$fromName['notice'] = ($params['from_user'] && isset($params['values']['お名前'])) ? $params['values']['お名前'] : $params['from_name'];
$body = '';

foreach ((array)$params['values'] as $key => $value) {
	$value = implode(',', (array)$value);
	if (preg_match('/\r\n|\r|\n/', $value)) {
		$value = "\n" . $value;
	}
	$body .=
		"------------------------------------------------------------\n" .
		htmlspecialchars($key) . '：' . htmlspecialchars($value) . "\n";
}
$body .= "------------------------------------------------------------\n";

// 通知メール送信.
if ($fromName['notice']) {
	$headers = 'From: ' . mb_encode_mimeheader(mb_convert_encoding($fromName['notice'], 'jis', 'auto')) . '<' . $from['notice'] . '>';
} else {
	$headers = 'From: ' . $from['notice'];
}
$headers .= "\n" . 'Return-Path: ' . $from['notice'];
if (mb_send_mail($to, $subject1, $bodyHead1 . $body, $headers)) {
	if ($params['auto_reply'] && isset($params['values']['メールアドレス'])) {

		// 自動返信メール送信.
		$to = $params['values']['メールアドレス'];
		if ($fromName['reply']) {
			$headers = 'From: ' . mb_encode_mimeheader(mb_convert_encoding($fromName['reply'], 'jis', 'auto')) . '<' . $from['reply'] . '>';
		} else {
			$headers = 'From: ' . $from['reply'];
		}
		$headers .= "\n" . 'Return-Path: ' . $from['reply'];
		mb_send_mail($to, $subject2, $bodyHead2 . $body, $headers);
	}
} else {
	if ($params['error_url']) {
		header('Location: ' . $params['error_url']);
	} else {
		exit('Error: システムエラーのためメールが送信できませんでした。恐れ入りますが、宛先をご確認の上、しばらく経ってから再度お試しください。');
	}
}

// サンクスページへリダイレクト.
header('Location: ' . $params['thanks_url']);

function convertEncodeArray($array, $to_encoding, $from_encoding)
{
	$array = (array)$array;
	foreach ($array as $key => $value) {
		if ($key !== ($key2 = mb_convert_encoding($key, $to_encoding, $from_encoding))) {
			unset($array[$key]);
			$key = $key2;
		}
		if (is_array($value)) {
			$array[$key] = convertEncodeArray($value, $to_encoding, $from_encoding);
		} else if (is_string($value)) {
			$array[$key] = mb_convert_encoding($value, $to_encoding, $from_encoding);
		}
	}
	return $array;
}
